
void _efl_ui_focus_layer_enable_set(Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Eina_Bool v);


static Eina_Error
__eolian_efl_ui_focus_layer_enable_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_focus_layer_enable_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_layer_enable_set, EFL_FUNC_CALL(v), Eina_Bool v);

Eina_Bool _efl_ui_focus_layer_enable_get(const Eo *obj, Efl_Ui_Focus_Layer_Data *pd);


static Eina_Value
__eolian_efl_ui_focus_layer_enable_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_focus_layer_enable_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_layer_enable_get, Eina_Bool, 0);

void _efl_ui_focus_layer_behaviour_set(Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Eina_Bool enable_on_visible, Eina_Bool cycle);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_layer_behaviour_set, EFL_FUNC_CALL(enable_on_visible, cycle), Eina_Bool enable_on_visible, Eina_Bool cycle);

void _efl_ui_focus_layer_behaviour_get(const Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Eina_Bool *enable_on_visible, Eina_Bool *cycle);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_focus_layer_behaviour_get, EFL_FUNC_CALL(enable_on_visible, cycle), Eina_Bool *enable_on_visible, Eina_Bool *cycle);

Efl_Ui_Focus_Manager *_efl_ui_focus_layer_efl_ui_widget_focus_manager_focus_manager_create(Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Efl_Ui_Focus_Object *root);


Eina_Bool _efl_ui_focus_layer_efl_ui_widget_focus_state_apply(Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Efl_Ui_Widget_Focus_State current_state, Efl_Ui_Widget_Focus_State *configured_state, Efl_Ui_Widget *redirect);


void _efl_ui_focus_layer_efl_gfx_entity_visible_set(Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Eina_Bool v);


Efl_Ui_Focus_Object *_efl_ui_focus_layer_efl_ui_focus_manager_move(Eo *obj, Efl_Ui_Focus_Layer_Data *pd, Efl_Ui_Focus_Direction direction);


Efl_Ui_Focus_Manager *_efl_ui_focus_layer_efl_ui_focus_object_focus_manager_get(const Eo *obj, Efl_Ui_Focus_Layer_Data *pd);


Efl_Ui_Focus_Object *_efl_ui_focus_layer_efl_ui_focus_object_focus_parent_get(const Eo *obj, Efl_Ui_Focus_Layer_Data *pd);


Efl_Object *_efl_ui_focus_layer_efl_object_constructor(Eo *obj, Efl_Ui_Focus_Layer_Data *pd);


void _efl_ui_focus_layer_efl_object_invalidate(Eo *obj, Efl_Ui_Focus_Layer_Data *pd);


static Eina_Bool
_efl_ui_focus_layer_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FOCUS_LAYER_EXTRA_OPS
#define EFL_UI_FOCUS_LAYER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_focus_layer_enable_set, _efl_ui_focus_layer_enable_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_layer_enable_get, _efl_ui_focus_layer_enable_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_layer_behaviour_set, _efl_ui_focus_layer_behaviour_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_layer_behaviour_get, _efl_ui_focus_layer_behaviour_get),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_manager_create, _efl_ui_focus_layer_efl_ui_widget_focus_manager_focus_manager_create),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_state_apply, _efl_ui_focus_layer_efl_ui_widget_focus_state_apply),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_set, _efl_ui_focus_layer_efl_gfx_entity_visible_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_move, _efl_ui_focus_layer_efl_ui_focus_manager_move),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_manager_get, _efl_ui_focus_layer_efl_ui_focus_object_focus_manager_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_focus_parent_get, _efl_ui_focus_layer_efl_ui_focus_object_focus_parent_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_focus_layer_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_focus_layer_efl_object_invalidate),
      EFL_UI_FOCUS_LAYER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"enable", __eolian_efl_ui_focus_layer_enable_set_reflect, __eolian_efl_ui_focus_layer_enable_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_focus_layer_class_desc = {
   EO_VERSION,
   "Efl.Ui.Focus.Layer",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_Ui_Focus_Layer_Data),
   _efl_ui_focus_layer_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_focus_layer_mixin_get, &_efl_ui_focus_layer_class_desc, NULL, EFL_UI_WIDGET_FOCUS_MANAGER_MIXIN, NULL);
